/**
 * Matrixes Module
 * @author James D Bloom 2003-03-12
 *
 * This module will have its code cleaned up (soon)
 * and more comments will be added so help
 * anyone who are tring to understand how is works
 */

package pipe.modules.matrixes;

import pipe.dataLayer.*;
import pipe.modules.Module;
import pipe.gui.*;
import javax.swing.*;
import javax.swing.text.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.awt.print.*;
import javax.swing.border.*;
import java.util.*;
import javax.swing.filechooser.FileFilter;
import javax.swing.event.MouseInputAdapter;

public class Matrixes implements Module {

  // Main Frame
  private static final String MODULE_NAME = "Incidence & Marking";
  private JFrame guiFrame = new JFrame("Petri-Net Incidence, Markup & Enabled Transitions Module");

  // Dimensions
  private final Toolkit mainToolKit = guiFrame.getToolkit(); // Get the window toolkit
  private final Dimension windowSize = mainToolKit.getScreenSize(); // Get screen size
  private final Point center = GraphicsEnvironment.getLocalGraphicsEnvironment().getCenterPoint(); // Get screen center
  private final int windowWidth = (windowSize.width*75)/100; // Window width in pixels
  private final int windowHeight = (windowSize.height*83)/100; // Window height in pixels
  private final int windowTopLeftCornerX = center.x-windowWidth/2; // Set window position
  private final int windowTopLeftCornerY = center.y-windowHeight/2; // Distance from top left corner of screen

  // Panels
  private JScrollPane scrollPane = null;
  private PrintableHTMLEditor editorPane = new PrintableHTMLEditor();
  private JPanel guiResultsPanel = null;
  private GridBagLayout gridbag = new GridBagLayout();
  private GridBagConstraints gridbagConstraints = new GridBagConstraints();
  private JPanel sourcePanel = new JPanel();

  // Text Fields
  private final int TEXT_FIELD_SIZE = 15;
  private JTextField sourceTextField = null;
  private JLabel sourceLabel = new JLabel();

  // Other
  private JButton sourceButton = new JButton();
  private JToolBar buttonBar = new JToolBar();
  private final Font defaultLabel = null;
  private DataLayer sourcedataLayer = null;
  private DataLayer refdataLayer = null; // Storeage (maintain reference) for input dataLayer parameter;
  private File outputHTML = null;
  private FileWriter outputWriter = null;
  private Insets spacing = new Insets((windowHeight*15)/1000,(windowWidth*15)/1000,(windowHeight*15)/1000,(windowWidth*15)/1000);
  private int fontScale = 10;
  // Checkboxes
  private JCheckBox sourceCheckBox = new JCheckBox();

  // Actions
  final static int NO_ACTION = -1;
  final static int CURRENT_NET = 0;
  final static int SOURCE_BROWSE = 1;

  public void run(DataLayer pnmlData) {
    Matrixes pnmlMatrixes = new Matrixes(pnmlData);
  }

  public String getName() {
    return MODULE_NAME;
  }

  public Matrixes(DataLayer pnmlData) {
    sourcedataLayer = pnmlData;
    sourceTextField = new JTextField(sourcedataLayer.getURI(), TEXT_FIELD_SIZE);
    try {
      initGuiFrame();
      } catch (java.lang.Exception e) {}
  }

  public Matrixes() {
    sourceTextField = new JTextField(TEXT_FIELD_SIZE);
  }

  private void initGuiFrame() throws Exception {
    outputHTML = new File("Matrixes.html");
    outputWriter = new FileWriter(outputHTML);
    guiFrame.setBounds(windowTopLeftCornerX, windowTopLeftCornerY, windowWidth, windowHeight);
    guiFrame.addMouseMotionListener(new MouseHandler());
    Container contentGuiPane = guiFrame.getContentPane();
    contentGuiPane.setLayout(new BorderLayout());
    JPanel guiPetriNetPanel = new JPanel();
    setUpPetriNetPanel(guiPetriNetPanel);
    guiPetriNetPanel.addMouseMotionListener(new MouseHandler());
    guiPetriNetPanel.setVisible(true);
    contentGuiPane.add(guiPetriNetPanel, BorderLayout.NORTH);
    setUpButtonBar();
    buttonBar.setVisible(true);
    buttonBar.addMouseMotionListener(new MouseHandler());
    contentGuiPane.add(buttonBar, BorderLayout.SOUTH);
    setUpResultsPanel();
    guiFrame.setVisible(true);
  }

  private void setUpButtonBar() {
    buttonBar.setBorder(BorderFactory.createEmptyBorder());

    // save as action listener and action
    JButton save = new JButton();
    save.addActionListener( new ActionListener(){
      public void actionPerformed(ActionEvent e)
      {
        try {
          saveas(editorPane.toString());
          } catch (IOException ioe) {}
      }
    });
    save.setBorder(BorderFactory.createRaisedBevelBorder()); // Add button border
    save.setPreferredSize(new Dimension(windowWidth,30));
    save.setText("Save");
    buttonBar.add(save);

    // load document action listener and action
    JButton load = new JButton();
    load.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        load();
      }
    });
    load.setBorder(BorderFactory.createRaisedBevelBorder()); // Add button border
    load.setPreferredSize(new Dimension(windowWidth,30));
    load.setText("Load");
    buttonBar.add(load);

    // refresh action listener and action
    JButton refresh = new JButton();
    refresh.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e) {
        editorPane.setVisible(false);
        sourcePanel.setVisible(false);
        guiResultsPanel.setVisible(false);
        buttonBar.setVisible(false);
        refreshResultsPanel("Matrixes.html");
        buttonBar.setVisible(true);
        editorPane.setVisible(true);
        sourcePanel.setVisible(true);
        guiResultsPanel.setVisible(true);
    }});
    refresh.setBorder(BorderFactory.createRaisedBevelBorder()); // Add button border
    refresh.setPreferredSize(new Dimension(windowWidth,30));
    refresh.setText("Recalculate");
    buttonBar.add(refresh);

    // increase action listener and action
    JButton increase = new JButton();
    increase.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e) {
        fontScale += 2;
        if(fontScale >= 30) fontScale -= 2;
        editorPane.setVisible(false);
        sourcePanel.setVisible(false);
        guiResultsPanel.setVisible(false);
        buttonBar.setVisible(false);
        refreshResultsPanel("Matrixes.html");
        buttonBar.setVisible(true);
        editorPane.setVisible(true);
        sourcePanel.setVisible(true);
        guiResultsPanel.setVisible(true);
    }});
    increase.setBorder(BorderFactory.createRaisedBevelBorder()); // Add button border
    increase.setPreferredSize(new Dimension(windowWidth,30));
    increase.setText("Increase Text Size");
    buttonBar.add(increase);

    // reduce action listener and action
    JButton reduce = new JButton();
    reduce.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e) {
        fontScale -= 2;
        if(fontScale <= 3) fontScale += 2;
        editorPane.setVisible(false);
        sourcePanel.setVisible(false);
        guiResultsPanel.setVisible(false);
        buttonBar.setVisible(false);
        refreshResultsPanel("Matrixes.html");
        buttonBar.setVisible(true);
        editorPane.setVisible(true);
        sourcePanel.setVisible(true);
        guiResultsPanel.setVisible(true);
    }});
    reduce.setBorder(BorderFactory.createRaisedBevelBorder()); // Add button border
    reduce.setPreferredSize(new Dimension(windowWidth,30));
    reduce.setText("Decrease Text Size");
    buttonBar.add(reduce);

    // print action listener and action
    JButton print = new JButton();
    print.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e) {
        PrinterJob pj=PrinterJob.getPrinterJob();
        pj.setPrintable(editorPane);
        pj.printDialog();
        try{
          pj.print();
          } catch (Exception PrintException) {}
          guiFrame.requestFocus();
          guiResultsPanel.requestFocus();
    }});
    print.setBorder(BorderFactory.createRaisedBevelBorder()); // Add button border
    print.setPreferredSize(new Dimension(windowWidth,30));
    print.setText("Print");
    buttonBar.add(print);

    // exit action listener and action
    JButton exit = new JButton();
    exit.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e) {
        guiResultsPanel.setVisible(false);
        guiFrame.setVisible(false);
    }});
    exit.setBorder(BorderFactory.createRaisedBevelBorder()); // Add button border
    exit.setPreferredSize(new Dimension(windowWidth,30));
    exit.setText("Close");
    buttonBar.add(exit);
  }


  private void setUpPetriNetPanel(JPanel panel){
    sourceCheckBox.addActionListener(new HandleControl(CURRENT_NET));
    sourceButton.addActionListener(new HandleControl(SOURCE_BROWSE));

    sourcePanel.setLayout(new FlowLayout());

    // Setup Source Box
    sourceCheckBox.setText("use current net");
    sourceCheckBox.setSelected(true);

    sourceButton.setText("Browse");
    sourceButton.setEnabled(false);
    sourceLabel.setText("Source-Net URI:");
    sourceLabel.setEnabled(false);
    sourceTextField.setEnabled(false);
    sourcePanel.setLayout(new FlowLayout());

    sourcePanel.add(sourceCheckBox);
    sourcePanel.add(sourceLabel);
    sourcePanel.add(sourceTextField);
    sourcePanel.add(sourceButton);
    sourcePanel.addMouseMotionListener(new MouseHandler());
    sourcePanel.setBorder(new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(165, 163, 151)),"Source Petri-Net", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, defaultLabel, Color.BLACK));

    // Add to panel
    panel.setLayout(gridbag);
    gridbagConstraints.insets = spacing;
    gridbag.setConstraints(sourcePanel, gridbagConstraints);
    panel.add(sourcePanel);
    panel.setBorder(BorderFactory.createEtchedBorder(Color.white,new Color(165, 163, 151)));
    panel.addMouseMotionListener(new MouseHandler());
    panel.setToolTipText("Specify the location of a Petri-Net");
  }

  private void setUpResultsPanel() {
    guiResultsPanel = new JPanel();
    guiResultsPanel.addMouseMotionListener(new MouseHandler());
    editorPane = new PrintableHTMLEditor();
    editorPane.setEditable(false);
    editorPane.setDragEnabled(false);
    editorPane.addMouseMotionListener(new MouseHandler());

    if(scrollPane != null)
      guiFrame.getContentPane().remove(scrollPane);
    scrollPane = new JScrollPane(editorPane);
    scrollPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
    scrollPane.addMouseMotionListener(new MouseHandler());
    writeHTML("Matrixes.html"); //"Matrixes.html"
    try { editorPane.setPage("file:" + outputHTML.getAbsolutePath()); } catch (IOException ioe) {}
    guiFrame.getContentPane().add(scrollPane, BorderLayout.CENTER);

    editorPane.setVisible(false);
    editorPane.setVisible(true);
    scrollPane.setVisible(false);
    scrollPane.setVisible(true);
    guiResultsPanel.setVisible(false);
    guiResultsPanel.setVisible(true);
  }

  private void writeHTML(String fileName){ //"Matrixes.html"
    try {
      Color background = guiResultsPanel.getBackground();
      background.getRed();
      background.getBlue();
      background.getGreen();
      int red = background.getRed();
      int blue = background.getBlue();
      int green = background.getGreen();
      int[][] incidenceMatrix = sourcedataLayer.getIncidenceMatrix();
      int[][] forwardIncidenceMatrix = sourcedataLayer.getFowardsIncidenceMatrix();
      int[][] backwardIncidenceMatrix = sourcedataLayer.getBackwardsIncidenceMatrix();
      int[] initialMarkupMatrix = sourcedataLayer.getInitialMarkupMatrix();
      int[] currentmarkupMatrix = sourcedataLayer.getCurrentMarkupMatrix();
      Transition[] transitions = sourcedataLayer.getTransitions();
      outputHTML.deleteOnExit();
      outputHTML = new File(fileName);
      outputHTML.createNewFile();
      outputWriter = new FileWriter(outputHTML);
      outputHTML.deleteOnExit();
      outputWriter.write("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2 Final//EN\">\n");
      outputWriter.write("<html>\n<head>\n");
      outputWriter.write("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=us-ascii\">\n");
      outputWriter.write("<title>Petri-Net Module Results</title>\n");
      outputWriter.write("<style type=\"text/css\">\n");
      outputWriter.write("th { color:blue; font-size:" + (3*fontScale)/2 + "pt; font-weight:normal; font-family:Franklin Gothic Medium,Georgia Ref,Arial,Geneva,sans-serif }\n");
      outputWriter.write("td { color:black; font-size:" + (3*fontScale)/2 + "pt; font-weight:normal; font-family:Verdana, Arial,Franklin Gothic Medium, Georgia Ref,Arial,Geneva,sans-serif }\n");
      outputWriter.write("</style>\n</head>\n<body>\n");
      outputWriter.write("<table align=\"center\" border=\"0\" cellpadding=\"" + (10*fontScale)/10 + "\">\n");
      if(sourcedataLayer != null) {
        if(forwardIncidenceMatrix.length > 0) {
          outputWriter.write("<tr>\n<th nowrap=\"nowrap\">\n<table cellpadding=\"" + (3*fontScale)/10 + "\" align=\"center\">\n");
          outputWriter.write("<tr>\n<th nowrap=\"nowrap\" colspan=\"" + (0 < forwardIncidenceMatrix.length ? forwardIncidenceMatrix[0].length+1 : forwardIncidenceMatrix.length+1) + "\" nowrap=\"nowrap\">\n<font face=\"Franklin Gothic Medium, Arial, Geneva, sans-serif\" color=\"black\" style=\"bold\" size=\"" + (6*fontScale)/10 + "\">Forwards Incidence</font></th></tr>\n");
          for (int i = 0 ; i <= forwardIncidenceMatrix.length ; i++) {
            outputWriter.write("<tr>\n");
            for (int j = 0 ; j <= forwardIncidenceMatrix[0].length ; j++) {
              if (j == 0 && i == 0) {
                outputWriter.write("<th nowrap=\"nowrap\"></th>\n");
              } else if (j == 0 && i != 0) {
                outputWriter.write("<th nowrap=\"nowrap\" align=\"center\">\n");
                if(sourcedataLayer.getPlace(i-1) != null) {
                  if(sourcedataLayer.getPlace(i-1).getName() != null) {
                    outputWriter.write(sourcedataLayer.getPlace(i-1).getName());
                  }
                }
                outputWriter.write("</th>\n");
              } else if (i == 0 && j != 0) {
                outputWriter.write("<th nowrap=\"nowrap\" align=\"center\">\n");
                if(sourcedataLayer.getTransition(j-1) != null) {
                  if(sourcedataLayer.getTransition(j-1).getName() != null) {
                    outputWriter.write(sourcedataLayer.getTransition(j-1).getName());
                  }
                }
                outputWriter.write("</th>\n");
              } else {
                outputWriter.write("<td align=\"center\">");
                if(i <= forwardIncidenceMatrix.length) {
                  if(j <= forwardIncidenceMatrix[i-1].length) {
                    outputWriter.write(Integer.toString(forwardIncidenceMatrix[i-1][j-1]));
                  }
                }
                outputWriter.write("</td>\n");
              }
            }
            outputWriter.write("</tr>\n");
          }
          outputWriter.write("</table>\n</th><th nowrap=\"nowrap\">\n</th><th nowrap=\"nowrap\">\n<table cellpadding=\"" + (3*fontScale)/10 + "\" align=\"center\">\n");
        }
        if(backwardIncidenceMatrix.length > 0) {
          outputWriter.write("<tr>\n<th nowrap=\"nowrap\" colspan=\"" + (0 < backwardIncidenceMatrix.length ? backwardIncidenceMatrix[0].length+1 : backwardIncidenceMatrix.length+1) + "\" nowrap=\"nowrap\">\n<font face=\"Franklin Gothic Medium, Arial, Geneva, sans-serif\" color=\"black\" style=\"bold\" size=\"" + (6*fontScale)/10 + "\">Backwards Incidence</font></th></tr>\n");
          for (int i = 0 ; i <= backwardIncidenceMatrix.length ; i++) {
            outputWriter.write("<tr>\n");
            for (int j = 0 ; j <= backwardIncidenceMatrix[0].length ; j++) {
              if (j == 0 && i == 0) {
                outputWriter.write("<th nowrap=\"nowrap\"></th>\n");
              } else if (j == 0 && i != 0) {
                outputWriter.write("<th nowrap=\"nowrap\" align=\"center\">\n");
                if(sourcedataLayer.getPlace(i-1) != null) {
                  if(sourcedataLayer.getPlace(i-1).getName() != null) {
                    outputWriter.write(sourcedataLayer.getPlace(i-1).getName());
                  }
                }
                outputWriter.write("</th>\n");
              } else if (i == 0 && j != 0) {
                outputWriter.write("<th nowrap=\"nowrap\" align=\"center\">\n");
                if(sourcedataLayer.getTransition(j-1) != null) {
                  if(sourcedataLayer.getTransition(j-1).getName() != null) {
                    outputWriter.write(sourcedataLayer.getTransition(j-1).getName());
                  }
                }
                outputWriter.write("</th>\n");
              } else {
                outputWriter.write("<td align=\"center\">");
                if(i <= backwardIncidenceMatrix.length) {
                  if(j <= backwardIncidenceMatrix[i-1].length) {
                    outputWriter.write(Integer.toString(backwardIncidenceMatrix[i-1][j-1]));
                  }
                }
                outputWriter.write("</td>\n");
              }
            }
            outputWriter.write("</tr>\n");
          }
          outputWriter.write("</table>\n</th>\n</tr><tr\n><th nowrap=\"nowrap\" colspan=\"3\">\n<table cellpadding=\"" + (4*fontScale)/10 + "\" align=\"center\">\n");
        }
        if(incidenceMatrix.length > 0) {
          outputWriter.write("<tr>\n<th nowrap=\"nowrap\"  colspan=\"" + (0 < incidenceMatrix.length ? incidenceMatrix[0].length+1 : incidenceMatrix.length+1) + "\" nowrap=\"nowrap\">\n<font face=\"Franklin Gothic Medium, Arial, Geneva, sans-serif\" color=\"black\" style=\"bold\" size=\"" + (6*fontScale)/10 + "\">Incidence</font></th></tr>\n");
          for (int i = 0 ; i <= incidenceMatrix.length ; i++) {
            outputWriter.write("<tr>\n");
            for (int j = 0 ; j <= incidenceMatrix[0].length ; j++) {
              if (j == 0 && i == 0) {
                outputWriter.write("<th nowrap=\"nowrap\"></th>\n");
              } else if (j == 0 && i != 0) {
                outputWriter.write("<th nowrap=\"nowrap\" align=\"center\">\n");
                if(sourcedataLayer.getPlace(i-1) != null) {
                  if(sourcedataLayer.getPlace(i-1).getName() != null) {
                    outputWriter.write(sourcedataLayer.getPlace(i-1).getName());
                  }
                }
                outputWriter.write("</th>\n");
              } else if (i == 0 && j != 0) {
                outputWriter.write("<th nowrap=\"nowrap\" align=\"center\">\n");
                if(sourcedataLayer.getTransition(j-1) != null) {
                  if(sourcedataLayer.getTransition(j-1).getName() != null) {
                    outputWriter.write("&nbsp;" + sourcedataLayer.getTransition(j-1).getName() + "&nbsp;");
                  }
                }
                outputWriter.write("</th>\n");
              } else {
                outputWriter.write("<td align=\"center\">");
                if(i <= incidenceMatrix.length) {
                  if(j <= incidenceMatrix[i-1].length) {
                    outputWriter.write("&nbsp;" + Integer.toString(incidenceMatrix[i-1][j-1]) + "&nbsp;");
                  }
                }
                outputWriter.write("</td>\n");
              }
            }
            outputWriter.write("</tr>\n");
          }
          outputWriter.write("</table>\n</th>\n</tr><tr>\n<th nowrap=\"nowrap\" colspan=\"3\">\n<table cellpadding=\"" + (8*fontScale)/10 + "\" align=\"center\">\n");
        }
        if(initialMarkupMatrix.length > 0) {
          outputWriter.write("<tr>\n<th nowrap=\"nowrap\" colspan=\"" + initialMarkupMatrix.length + "\" nowrap=\"nowrap\">\n<font face=\"Franklin Gothic Medium, Arial, Geneva, sans-serif\" color=\"black\" style=\"bold\" size=\"" + (6*fontScale)/10 + "\">Initial Marking</font></th></tr>\n");
          outputWriter.write("<tr>\n");
          for (int i = 0 ; i < initialMarkupMatrix.length ; i++) {
            outputWriter.write("<th nowrap=\"nowrap\" align=\"center\">\n");
            if(sourcedataLayer.getPlace(i) != null) {
              if(sourcedataLayer.getPlace(i).getName() != null) {
                outputWriter.write(sourcedataLayer.getPlace(i).getName());
              }
            }
            outputWriter.write("</th>\n");
          }
          outputWriter.write("</tr><tr>");
          for (int i = 0 ; i < initialMarkupMatrix.length ; i++) {
            outputWriter.write("<td align=\"center\">");
            if(i < initialMarkupMatrix.length) {
              outputWriter.write(Integer.toString(initialMarkupMatrix[i]));
            }
            outputWriter.write("</td>\n");
          }
          outputWriter.write("</tr>\n</table>\n</th>\n</tr><tr>\n<th nowrap=\"nowrap\" colspan=\"3\">\n<table cellpadding=\"" + (5*fontScale)/10 + "\" align=\"center\">\n");
        }
        if(currentmarkupMatrix.length > 0) {
          outputWriter.write("<tr>\n<th nowrap=\"nowrap\" colspan=\"" + currentmarkupMatrix.length + "\" nowrap=\"nowrap\">\n<font face=\"Franklin Gothic Medium, Arial, Geneva, sans-serif\" color=\"black\" style=\"bold\" size=\"" + (6*fontScale)/10 + "\">Current Marking</font></th></tr>\n");
          outputWriter.write("<tr>\n");
          for (int i = 0 ; i < currentmarkupMatrix.length ; i++) {
            outputWriter.write("<th nowrap=\"nowrap\" align=\"center\">\n");
            if(sourcedataLayer.getPlace(i) != null) {
              if(sourcedataLayer.getPlace(i).getName() != null) {
                outputWriter.write(sourcedataLayer.getPlace(i).getName());
              }
            }
            outputWriter.write("</th>\n");
          }
          outputWriter.write("</tr><tr>");
          for (int i = 0 ; i < currentmarkupMatrix.length ; i++) {
            outputWriter.write("<td align=\"center\">");
            if(i < currentmarkupMatrix.length) {
              outputWriter.write(Integer.toString(currentmarkupMatrix[i]));
            }
            outputWriter.write("</td>\n");
          }
          outputWriter.write("</tr>\n</table>\n</th>\n</tr><tr>\n<th nowrap=\"nowrap\" colspan=\"3\">\n<table cellpadding=\"" + (5*fontScale)/10 + "\" align=\"center\">\n");
        }
        if(transitions.length > 0) {
          outputWriter.write("<tr>\n<th nowrap=\"nowrap\"><br>\n<font face=\"Franklin Gothic Medium, Arial, Geneva, sans-serif\" color=\"black\" style=\"bold\" size=\"" + (6*fontScale)/10 + "\">Enabled Transitions:&nbsp;&nbsp;&nbsp;&nbsp;</font><font color=\"red\">\n");
          sourcedataLayer.setEnabledTransitions();
          for (int i = 0 ; i < transitions.length ; i++) {
            if(transitions[i].isEnabled() == true) {
              if(transitions[i].getName() != null) {
                outputWriter.write(transitions[i].getName() + ",    ");
              }
            }
          }
          sourcedataLayer.resetEnabledTransitions();
          outputWriter.write("</font><br>\n</th>\n</tr>\n</table>\n</th>\n</tr><tr>\n<th nowrap=\"nowrap\" colspan=\"3\">\n<table cellpadding=\"" + (5*fontScale)/10 + "\" align=\"center\">\n");
        }
        if(transitions.length > 0) {
          outputWriter.write("<tr>\n<th nowrap=\"nowrap\"><br>\n<font face=\"Franklin Gothic Medium, Arial, Geneva, sans-serif\" color=\"black\" style=\"bold\" size=\"" + (6*fontScale)/10 + "\">Un-Enabled Transitions:&nbsp;&nbsp;&nbsp;&nbsp;</font>\n");
          sourcedataLayer.setEnabledTransitions();
          for (int i = 0 ; i < transitions.length ; i++) {
            if(transitions[i].isEnabled() == false) {
              if(transitions[i].getName() != null) {
                outputWriter.write(transitions[i].getName() + ",&nbsp;&nbsp;&nbsp;");
              }
            }
          }
          sourcedataLayer.resetEnabledTransitions();
          outputWriter.write("<br>\n</th>\n</tr>\n</table>\n</th>\n</tr>\n");
        }
      }
      outputWriter.write("</table>\n<br>");
      outputWriter.write("</body></html>");
      outputWriter.close();
      } catch (IOException ioe) {}
  }

  private void refreshResultsPanel(String fileName){
    Color background = guiResultsPanel.getBackground();
    background.getRed();
    background.getBlue();
    background.getGreen();

    int red = background.getRed();
    int blue = background.getBlue();
    int green = background.getGreen();
    int[][] incidenceMatrix = sourcedataLayer.getIncidenceMatrix();
    int[][] forwardIncidenceMatrix = sourcedataLayer.getFowardsIncidenceMatrix();
    int[][] backwardIncidenceMatrix = sourcedataLayer.getBackwardsIncidenceMatrix();
    int[] initialMarkupMatrix = sourcedataLayer.getInitialMarkupMatrix();
    int[] currentmarkupMatrix = sourcedataLayer.getInitialMarkupMatrix();
    Transition[] transitions = sourcedataLayer.getTransitions();
    editorPane.setVisible(false);
    scrollPane.setVisible(false);
    guiResultsPanel.setVisible(false);

    if(editorPane != null)
      scrollPane.remove(editorPane);
    editorPane = new PrintableHTMLEditor();
    editorPane.setEditable(false);
    editorPane.setDragEnabled(false);
    editorPane.setEnabled(false);
    writeHTML("Matrixes.html"); //"Matrixes.html"
    try { editorPane.setPage("file:" + outputHTML.getAbsolutePath()); } catch (IOException ioe) {}
    editorPane.addMouseMotionListener(new MouseHandler());

    if(scrollPane != null)
      guiFrame.getContentPane().remove(scrollPane);
    scrollPane = new JScrollPane(editorPane);
    scrollPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
    scrollPane.addMouseMotionListener(new MouseHandler());

    guiFrame.getContentPane().add(scrollPane, BorderLayout.CENTER);

    editorPane.setVisible(true);
    scrollPane.setVisible(true);
    guiResultsPanel.setVisible(true);

  }

  private void warnUser(String message, JFrame frame) {
    JOptionPane.showMessageDialog(frame, message, "Petri-Net Matrixes Module", JOptionPane.CLOSED_OPTION);
  }

  // Handle redrawing
  public class MouseHandler extends MouseInputAdapter {

    public void mouseMoved(MouseEvent e) {
      editorPane.setVisible(false);
      editorPane.setVisible(true);
      buttonBar.setVisible(false);
      buttonBar.setVisible(true);
      guiResultsPanel.setVisible(false);
      guiResultsPanel.setVisible(true);
      sourcePanel.setVisible(false);
      sourcePanel.setVisible(true);
    }
  }

  // Class defining a handler for a control button
  public class HandleControl implements ActionListener {
    private int buttonID;

    // Constructor
    public HandleControl(int buttonID) {
      this.buttonID = buttonID; // Store the button ID
    }

    private String openFile(File file, String title, JTextField textField) {

      int fileChooserReturnVal = JFileChooser.ERROR_OPTION;
      JFileChooser fileChooser = null;
      if(sourcedataLayer.getURI() != null)
        fileChooser = new JFileChooser(sourcedataLayer.getURI());
      else
        fileChooser = new JFileChooser();

      String explain = "Please select " + title;

      fileChooser.setToolTipText(explain);
      fileChooser.setName(explain);
      fileChooser.setDialogType(JFileChooser.OPEN_DIALOG);
      fileChooser.setDialogTitle(explain);
      fileChooser.setFileSelectionMode(fileChooser.FILES_ONLY);
      ExtensionFilter netFilter = new ExtensionFilter(".xml","Petri-Net files (*.xml)");

      fileChooser.setAcceptAllFileFilterUsed(false); // Remove 'all files'filter
      fileChooser.addChoosableFileFilter(netFilter); // add Filter
      fileChooser.setFileFilter(netFilter); // and select it
      fileChooser.rescanCurrentDirectory();

      if(file != null)
        fileChooser.setSelectedFile(file);

      fileChooserReturnVal = fileChooser.showOpenDialog(guiFrame);

      if (fileChooserReturnVal == JFileChooser.APPROVE_OPTION) {

        file = fileChooser.getSelectedFile();

        if (file.getName().endsWith(".xml")) {

          try {

            if(file != null) {
              sourcedataLayer = new DataLayer(file);
              refreshResultsPanel("Matrixes.html");
            }


          } catch (java.io.IOException ex) {
            warnUser("java.io.IOException " + ex + " File Access Error with " + title, guiFrame);
          } catch (org.xml.sax.SAXException ex) {
            warnUser("org.xml.sax.SAXException " + ex + " File Access Error with " + title, guiFrame);
          } catch (javax.xml.transform.TransformerException  ex) {
            warnUser("javax.xml.transform.TransformerException " + ex + " File Access Error with " + title, guiFrame);
          } catch (javax.xml.parsers.ParserConfigurationException  ex) {
            warnUser("javax.xml.parsers.ParserConfigurationException " + ex + " File Access Error with " + title, guiFrame);
          }

        } else {
          int returnVal = JOptionPane.showConfirmDialog(guiFrame, "Incorrect file type selected do you want to try again?", "Please select a Petri-Net File (*.xml)", JOptionPane.YES_NO_OPTION, JOptionPane.PLAIN_MESSAGE);
          if(returnVal == JOptionPane.YES_OPTION) {
            textField.setText(null);
            file = null;
            return openFile(file, title, textField);
          }
        }
        guiResultsPanel = new JPanel();
        guiResultsPanel.addMouseMotionListener(new MouseHandler());
        writeHTML("Matrixes.html"); //"Matrixes.html"
        try { editorPane.setPage("file:" + outputHTML.getAbsolutePath()); } catch (IOException ioe) {}
/*
        Color background = guiResultsPanel.getBackground();
        background.getRed();
        background.getBlue();
        background.getGreen();

        int red = background.getRed();
        int blue = background.getBlue();
        int green = background.getGreen();
        int[][] incidenceMatrix = sourcedataLayer.getIncidenceMatrix();
        int[][] forwardIncidenceMatrix = sourcedataLayer.getFowardsIncidenceMatrix();
        int[][] backwardIncidenceMatrix = sourcedataLayer.getBackwardsIncidenceMatrix();
        int[] initialMarkupMatrix = sourcedataLayer.getInitialMarkupMatrix();
        int[] currentmarkupMatrix = sourcedataLayer.getInitialMarkupMatrix();

        try {
          outputHTML = new File("Matrixes.html");
          outputHTML.createNewFile();
          outputWriter = new FileWriter(outputHTML);

          outputHTML.deleteOnExit();

          outputWriter.write("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2 Final//EN\">");
          outputWriter.write("<META http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">");
          outputWriter.write("<html><head><title>Petri-Net Module Results</title><style type=\"text/css\">");
          outputWriter.write("th { color:blue; font-size:" + (3*fontScale)/2 + "pt; font-weight:normal; font-family:Franklin Gothic Medium,Georgia Ref,Arial,Geneva,sans-serif }");
          outputWriter.write("td { color:black; font-size:" + (3*fontScale)/2 + "pt; font-weight:normal; font-family:Verdana, Arial,Franklin Gothic Medium, Georgia Ref,Arial,Geneva,sans-serif }");
//    outputWriter.write("</style></head><body bgcolor=\"rgb(" + red + "," + green + "," + blue + ")\">");
          outputWriter.write("</style></head><body>");
          outputWriter.write("<p align=\"center\"><table align=\"center\" border=\"0\" cellpadding=\"" + (10*fontScale)/10 + "\">");
          if(sourcedataLayer != null) {
            if(forwardIncidenceMatrix.length > 0) {
              outputWriter.write("<tr><th nowrap=\"nowrap\" ><table cellpadding=\"" + (3*fontScale)/10 + "\" align=\"center\">");
              outputWriter.write("<tr><th nowrap=\"nowrap\"  colspan=\"" + (0 < forwardIncidenceMatrix.length ? forwardIncidenceMatrix[0].length+1 : forwardIncidenceMatrix.length+1) + "\" nowrap=\"nowrap\"><font face=\"Franklin Gothic Medium, Arial, Geneva, sans-serif\" color=\"black\" style=\"bold\" size=\"" + (6*fontScale)/10 + "\">Forwards Incidence</font></th></tr>");
              for (int i = 0 ; i <= forwardIncidenceMatrix.length ; i++) {
                outputWriter.write("<tr>\n");
                for (int j = 0 ; j <= forwardIncidenceMatrix[0].length ; j++) {
                  if (j == 0 && i == 0) {
                    outputWriter.write("<th nowrap=\"nowrap\"></th>\n");
                  } else if (j == 0 && i != 0) {
                    outputWriter.write("<th nowrap=\"nowrap\" align=\"center\">\n");
                    if(sourcedataLayer.getPlace(i-1) != null) {
                      if(sourcedataLayer.getPlace(i-1).getName() != null) {
                        outputWriter.write(sourcedataLayer.getPlace(i-1).getName());
                      }
                    }
                    outputWriter.write("</th>\n");
                  } else if (i == 0 && j != 0) {
                    outputWriter.write("<th nowrap=\"nowrap\" align=\"center\">\n");
                    if(sourcedataLayer.getTransition(j-1) != null) {
                      if(sourcedataLayer.getTransition(j-1).getName() != null) {
                        outputWriter.write(sourcedataLayer.getTransition(j-1).getName());
                      }
                    }
                    outputWriter.write("</th>\n");
                  } else {
                    outputWriter.write("<td align=\"center\">");
                    if(i <= forwardIncidenceMatrix.length) {
                      if(j <= forwardIncidenceMatrix[i-1].length) {
                        outputWriter.write(Integer.toString(forwardIncidenceMatrix[i-1][j-1]));
                      }
                    }
                    outputWriter.write("</td>\n");
                  }
                }
                outputWriter.write("</tr>\n");
              }
              outputWriter.write("</table></th><th nowrap=\"nowrap\" ></th><th nowrap=\"nowrap\" ><table cellpadding=\"" + (3*fontScale)/10 + "\" align=\"center\">");
            }
            if(backwardIncidenceMatrix.length > 0) {
              outputWriter.write("<tr><th nowrap=\"nowrap\"  colspan=\"" + (0 < backwardIncidenceMatrix.length ? backwardIncidenceMatrix[0].length+1 : backwardIncidenceMatrix.length+1) + "\" nowrap=\"nowrap\"><font face=\"Franklin Gothic Medium, Arial, Geneva, sans-serif\" color=\"black\" style=\"bold\" size=\"" + (6*fontScale)/10 + "\">Backwards Incidence</font></th></tr>");
              for (int i = 0 ; i <= backwardIncidenceMatrix.length ; i++) {
                outputWriter.write("<tr>\n");
                for (int j = 0 ; j <= backwardIncidenceMatrix[0].length ; j++) {
                  if (j == 0 && i == 0) {
                    outputWriter.write("<th nowrap=\"nowrap\"></th>\n");
                  } else if (j == 0 && i != 0) {
                    outputWriter.write("<th nowrap=\"nowrap\" align=\"center\">\n");
                    if(sourcedataLayer.getPlace(i-1) != null) {
                      if(sourcedataLayer.getPlace(i-1).getName() != null) {
                        outputWriter.write(sourcedataLayer.getPlace(i-1).getName());
                      }
                    }
                    outputWriter.write("</th>\n");
                  } else if (i == 0 && j != 0) {
                    outputWriter.write("<th nowrap=\"nowrap\" align=\"center\">\n");
                    if(sourcedataLayer.getTransition(j-1) != null) {
                      if(sourcedataLayer.getTransition(j-1).getName() != null) {
                        outputWriter.write(sourcedataLayer.getTransition(j-1).getName());
                      }
                    }
                    outputWriter.write("</th>\n");
                  } else {
                    outputWriter.write("<td align=\"center\">");
                    if(i <= backwardIncidenceMatrix.length) {
                      if(j <= backwardIncidenceMatrix[i-1].length) {
                        outputWriter.write(Integer.toString(backwardIncidenceMatrix[i-1][j-1]));
                      }
                    }
                    outputWriter.write("</td>\n");
                  }
                }
                outputWriter.write("</tr>\n");
              }
              outputWriter.write("</table></th></tr><tr><th nowrap=\"nowrap\"  colspan=\"3\"><table cellpadding=\"" + (8*fontScale)/10 + "\" align=\"center\">");
            }
            if(incidenceMatrix.length > 0) {
              outputWriter.write("<tr><th nowrap=\"nowrap\"  colspan=\"" + (0 < incidenceMatrix.length ? incidenceMatrix[0].length+1 : incidenceMatrix.length+1) + "\" nowrap=\"nowrap\"><font face=\"Franklin Gothic Medium, Arial, Geneva, sans-serif\" color=\"black\" style=\"bold\" size=\"" + (6*fontScale)/10 + "\">Incidence</font></th></tr>");
              for (int i = 0 ; i <= incidenceMatrix.length ; i++) {
                outputWriter.write("<tr>\n");
                for (int j = 0 ; j <= incidenceMatrix[0].length ; j++) {
                  if (j == 0 && i == 0) {
                    outputWriter.write("<th nowrap=\"nowrap\"></th>\n");
                  } else if (j == 0 && i != 0) {
                    outputWriter.write("<th nowrap=\"nowrap\" align=\"center\">\n");
                    if(sourcedataLayer.getPlace(i-1) != null) {
                      if(sourcedataLayer.getPlace(i-1).getName() != null) {
                        outputWriter.write(sourcedataLayer.getPlace(i-1).getName());
                      }
                    }
                    outputWriter.write("</th>\n");
                  } else if (i == 0 && j != 0) {
                    outputWriter.write("<th nowrap=\"nowrap\" align=\"center\">\n");
                    if(sourcedataLayer.getTransition(j-1) != null) {
                      if(sourcedataLayer.getTransition(j-1).getName() != null) {
                        outputWriter.write("&nbsp;" + sourcedataLayer.getTransition(j-1).getName() + "&nbsp");
                      }
                    }
                    outputWriter.write("</th>\n");
                  } else {
                    outputWriter.write("<td align=\"center\">");
                    if(i <= incidenceMatrix.length) {
                      if(j <= incidenceMatrix[i-1].length) {
                        outputWriter.write("&nbsp;" + Integer.toString(incidenceMatrix[i-1][j-1]) + "&nbsp");
                      }
                    }
                    outputWriter.write("</td>\n");
                  }
                }
                outputWriter.write("</tr>\n");
              }
              outputWriter.write("</table></th></tr><tr><th nowrap=\"nowrap\"  colspan=\"3\"><table cellpadding=\"" + (8*fontScale)/10 + "\" align=\"center\">");
            }
            if(initialMarkupMatrix.length > 0) {
              outputWriter.write("<tr><th nowrap=\"nowrap\"  colspan=\"" + initialMarkupMatrix.length + "\" nowrap=\"nowrap\"><font face=\"Franklin Gothic Medium, Arial, Geneva, sans-serif\" color=\"black\" style=\"bold\" size=\"" + (6*fontScale)/10 + "\">Initial Markup</font></th></tr>");
              outputWriter.write("<tr>\n");
              for (int i = 0 ; i < initialMarkupMatrix.length ; i++) {
                outputWriter.write("<th nowrap=\"nowrap\" align=\"center\">\n");
                if(sourcedataLayer.getPlace(i) != null) {
                  if(sourcedataLayer.getPlace(i).getName() != null) {
                    outputWriter.write(sourcedataLayer.getPlace(i).getName());
                  }
                }
                outputWriter.write("</th>\n");
              }
              outputWriter.write("</tr><tr>");
              for (int i = 0 ; i < initialMarkupMatrix.length ; i++) {
                outputWriter.write("<td align=\"center\">");
                if(i < initialMarkupMatrix.length) {
                  outputWriter.write(Integer.toString(initialMarkupMatrix[i]));
                }
                outputWriter.write("</td>\n");
              }
              outputWriter.write("</tr></table></th></tr><tr><th nowrap=\"nowrap\"  colspan=\"3\"><table cellpadding=\"" + (8*fontScale)/10 + "\" align=\"center\">");
            }
            if(currentmarkupMatrix.length > 0) {
              outputWriter.write("<tr><th nowrap=\"nowrap\"  colspan=\"" + currentmarkupMatrix.length + "\" nowrap=\"nowrap\"><font face=\"Franklin Gothic Medium, Arial, Geneva, sans-serif\" color=\"black\" style=\"bold\" size=\"" + (6*fontScale)/10 + "\">Current Markup</font></th></tr>");
              outputWriter.write("<tr>\n");
              for (int i = 0 ; i < currentmarkupMatrix.length ; i++) {
                outputWriter.write("<th nowrap=\"nowrap\" align=\"center\">\n");
                if(sourcedataLayer.getPlace(i) != null) {
                  if(sourcedataLayer.getPlace(i).getName() != null) {
                    outputWriter.write(sourcedataLayer.getPlace(i).getName());
                  }
                }
                outputWriter.write("</th>\n");
              }
              outputWriter.write("</tr><tr>");
              for (int i = 0 ; i < currentmarkupMatrix.length ; i++) {
                outputWriter.write("<td align=\"center\">");
                if(i < initialMarkupMatrix.length) {
                  outputWriter.write(Integer.toString(initialMarkupMatrix[i]));
                }
                outputWriter.write("</td>\n");
              }
              outputWriter.write("</tr>\n");
              outputWriter.write("</table></th></tr>");
            }
          }
          outputWriter.write("</table>");

          outputWriter.write("</p></body></html>");
          outputWriter.close();
          editorPane.setEditable(false);
          editorPane.setDragEnabled(false);
          editorPane.setAutoscrolls(true);
          editorPane.setBackground(background);
          editorPane.setPage("file:" + outputHTML.getAbsolutePath());
//    JPanel htmlPane = new JPanel();
//    htmlPane.add(editorPane);
//    JPanel htmlOuterPane = new JPanel();
//    htmlOuterPane.add(editorPane);
          JScrollPane scrollPane = new JScrollPane(editorPane);
          scrollPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));

          guiFrame.getContentPane().add(scrollPane, BorderLayout.CENTER);
          guiFrame.addMouseMotionListener(new MouseHandler());
          } catch (IOException e) {}
*/
        guiFrame.setVisible(false);
        guiFrame.setVisible(true);

      }

      if(file == null) return null;

      return file.getName();
    }

    // Handle button click
    public void actionPerformed(ActionEvent e) {
      File sourceFile = null;

      switch(buttonID) {
        case NO_ACTION:
          break;
        case CURRENT_NET:
          guiResultsPanel.setVisible(false);
          guiResultsPanel.setVisible(true);
          if(sourceCheckBox.isSelected()) {
            sourceButton.setEnabled(false);
            sourceLabel.setEnabled(false);
            sourceTextField.setEnabled(false);
            sourcedataLayer = refdataLayer;
          } else {
            sourceButton.setEnabled(true);
            sourceLabel.setEnabled(true);
            sourceTextField.setEnabled(true);
            refdataLayer = sourcedataLayer;
          }
          sourceTextField.setText(sourcedataLayer.getURI());
          break;
        case SOURCE_BROWSE:
          guiResultsPanel.setVisible(false);
          sourceTextField.setText(openFile(sourceFile,  "the Source Petri-Net file", sourceTextField));
//          try {
          setUpResultsPanel();
//            } catch (IOException ioe) { warnUser("Internal File Error", guiFrame); }
          guiResultsPanel.setVisible(true);
          break;
      }
    }
  }
  public class Matrix {
    private int[][] matrix = null;
    public static final int OUT_OF_BOUNDS_ERROR = -666666666;

    public Matrix(int i, int j) {
      matrix = new int[i][j];
    }

    public Matrix(int[][] matrix) {
      this.matrix = matrix;
    }

    public void setToZero() {
      for(int i = 0 ; i < matrix.length ; i++)
        for(int j = 0 ; j < matrix[i].length ; j++)
          matrix[i][j] = 0;
    }

    public void add(Matrix matrixInput) {
      int[][] matrixIntputIntArray = matrixInput.getIntArray();

      for(int i = 0 ; i < matrix.length ; i++)
        for(int j = 0 ; j < matrix[i].length ; j++)
          matrix[i][j] += matrixIntputIntArray[i][j];
    }

    public void set(int i, int j, int value) {
      if(i < matrix.length && j < matrix[i].length) {
        matrix[i][j] = value;
      }
    }

    public int get(int i, int j) {
      if(i < matrix.length && j < matrix[i].length)
        return matrix[i][j];
      else
        return OUT_OF_BOUNDS_ERROR;
    }

    public int[][] getIntArray() {
      return matrix;
    }

  }
  public class PrintableHTMLEditor extends JEditorPane implements Printable {
    // print function
    public int print(Graphics g, PageFormat pageFormat, int pageIndex) throws PrinterException {
      Graphics2D  g2 = (Graphics2D) g;
      g2.setColor(Color.black);
      int fontHeight=g2.getFontMetrics().getHeight();
      int fontDesent=g2.getFontMetrics().getDescent();

      //leave room for page number
      double pageHeight = pageFormat.getImageableHeight()-fontHeight;
      double pageWidth = pageFormat.getImageableWidth();
      double scaleX = 0.5;
      double scaleY = 0.5;
      int totalNumPages = 1;

      if(pageIndex>=totalNumPages) {
        return Printable.NO_SUCH_PAGE;
      }

      g2.translate(pageFormat.getImageableX(), pageFormat.getImageableY());
      g2.scale(scaleX,scaleY);
      editorPane.paint(g2);
      g2.scale(1/scaleX,1/scaleY);
      g2.scale(scaleX,scaleY);

      return Printable.PAGE_EXISTS;
    }
  }

  // load function
  public void load() {
    JFileChooser fileChooser = new JFileChooser(sourcedataLayer.getURI());
    String explain = "Please select a file to load...";

    fileChooser.setToolTipText(explain);
    fileChooser.setName(explain);
    fileChooser.setDialogType(JFileChooser.OPEN_DIALOG);
    fileChooser.setDialogTitle(explain);
    fileChooser.setFileSelectionMode(fileChooser.FILES_ONLY);
    ExtensionFilter netFilter = new ExtensionFilter(".html","Petri-Net Matrix files (*.html)");
    ExtensionFilter txtFilter = new ExtensionFilter(".txt","Text files (*.txt)");

    fileChooser.setAcceptAllFileFilterUsed(false); // Remove 'all files'filter
    fileChooser.addChoosableFileFilter(netFilter); // add Filter
    fileChooser.addChoosableFileFilter(txtFilter); // add Filter
    fileChooser.setFileFilter(netFilter); // and select it
    fileChooser.rescanCurrentDirectory();

    int n = fileChooser.showOpenDialog(guiResultsPanel);

    if(n == JFileChooser.CANCEL_OPTION)
      return;

    File thefile = fileChooser.getSelectedFile(); //.getName();

    if (thefile == null || thefile.getName().equals("")){
      JOptionPane.showMessageDialog(guiResultsPanel, "Invalid File Name", "Invalid File Name", JOptionPane.ERROR_MESSAGE);
    }
    else {
      try {
        editorPane.setVisible(false);
        editorPane.setPage("file:" + thefile.getAbsolutePath());
        sourceTextField.setText(thefile.getAbsolutePath());
        editorPane.setVisible(true);
      }
      catch (IOException e) {
        JOptionPane.showMessageDialog(guiResultsPanel, "Error Operning File", "Error", JOptionPane.ERROR_MESSAGE);
      }
    }
  }

  // saveas function
  public void saveas(String text) throws IOException {
    JFileChooser fileChooser = null;
    if(sourcedataLayer.getURI() != null)
      fileChooser = new JFileChooser(sourcedataLayer.getURI());
    else
      fileChooser = new JFileChooser();
    String explain = "Please select a file to load...";

    fileChooser.setToolTipText(explain);
    fileChooser.setName(explain);
    fileChooser.setDialogType(JFileChooser.OPEN_DIALOG);
    fileChooser.setDialogTitle(explain);
    fileChooser.setFileSelectionMode(fileChooser.FILES_ONLY);
    ExtensionFilter netFilter = new ExtensionFilter(".html","Matrix / Comparison / Classification Result files (*.html)");
    ExtensionFilter txtFilter = new ExtensionFilter(".txt","Text files (*.txt)");

    fileChooser.setAcceptAllFileFilterUsed(false); // Remove 'all files'filter
    fileChooser.addChoosableFileFilter(netFilter); // add Filter
    fileChooser.addChoosableFileFilter(txtFilter); // add Filter
    fileChooser.setFileFilter(netFilter); // and select it
    fileChooser.rescanCurrentDirectory();

    int n = fileChooser.showSaveDialog(guiResultsPanel);

    if(n == JFileChooser.CANCEL_OPTION)
      return;

    File thefile = fileChooser.getSelectedFile(); //.getName();

    if (thefile == null || thefile.getName().equals("")){
      JOptionPane.showMessageDialog(guiResultsPanel, "Invalid File Name", "Invalid File Name", JOptionPane.ERROR_MESSAGE);
    }
    else {
      refreshResultsPanel((thefile.getName().endsWith(".html") ? thefile.getName() : (thefile.getName().endsWith(".htm") ? thefile.getName() : thefile.getName() + ".html")));
    }
  }
}